<?php
/*
Plugin Name: Yahoo Messenger Online Status
Plugin URI: http://hudatoriq.web.id/2007/05/01/yahoo-messenger-online-status-plugin-for-wordpress/
Description: A plugin that creates an icon/button that shows your Yahoo Messenger Online Status.
Author: Huda Toriq
Version: 0.1
Author URI: http://hudatoriq.web.id/
*/

define("YM_STATUS_BASE_DIR", "ym-online-status/");
define("YM_STATUS_DIR", "wp-content/plugins/" . YM_STATUS_BASE_DIR);
define("YM_STATUS_IMG_DIR", YM_STATUS_DIR . "images/");

/* Define the supported extension for images used in the online status. File format undefined below will not show up in the YM Status Options Menu */
$supported_image_extension = array('jpg','jpeg','png','gif','bmp');
$ym_options = unserialize(get_option('ym_status'));

function activated() {
	$ym_id = array();
	$ym_button = "";
	$ym_title = "";
	$ym_status = array("id" => $ym_id, "button" => $ym_button, "title" => $ym_title);
	$ym_status = serialize($ym_status);
	add_option('ym_status', $ym_status);
}

function deactivated() {
	//Clear settings from wp_options when deactivating this plugin. It means all your settings are lost, but don't worry. It won't delete your customized button.
	delete_option('ym_status');
}

function ym_status_menu() {
	load_plugin_textdomain('ym_status', YM_STATUS_DIR);
	add_options_page(__('YM Status', 'ym_status'), __('YM Status', 'ym_status'), 9, __FILE__, 'ym_status_option');
}

function is_supported_image($image, $supported_extension) {
	$supported = false;
	$fileinfo = pathinfo($image);
	foreach($supported_extension as $value) {
		if($fileinfo['extension'] == $value) {
			$supported = true;
		}
	}
	return $supported;
}

function ym_status_option() {
	global $supported_image_extension, $ym_options;
	define("YM_STATUS_DIR_REL", "../" . YM_STATUS_DIR);
	load_plugin_textdomain('ym_status', YM_STATUS_DIR);
	$dir = "../" . YM_STATUS_IMG_DIR;
	
	if ($handle = opendir($dir)) {
		while (false !== ($filename = readdir($handle))) { 
			if ($filename != "." && $file != "..") { 
				$filepath = "../" . YM_STATUS_IMG_DIR . $filename;
				if(is_file($filepath)) {
					if(is_supported_image($filepath, $supported_image_extension)) {
						if(substr($filename, 0, 7) == 'online-') {
							$online[] = $filename;
						} elseif(substr($filename, 0, 8) == 'offline-') {
							$offline[] = $filename;
						}
					}
				}
			} 
		}
    closedir($handle); 
	}

	$pairs = count($online);
	$ym_id = implode(" ", $ym_options['id']);
	$ym_title = $ym_options['title'];
	$ym_selected_button = $ym_options['button'];
	
	?> 
	<div class="wrap">
		<h2><?php _e('Yahoo Messenger Online Status', 'ym_status'); ?></h2>
		<form method="post" action="">
		<p class="submit"><input type="submit" name="submit" value="<?php _e('Update Options &raquo;','ym_status') ?>" /></p>
		<table class="optiontable"> 
			<tr valign="top"> 
				<th scope="row"><?php _e('Yahoo Messenger ID(s)', 'ym_status'); ?>:</th> 
				<td colspan="3"><input name="yahoo_id" type="text" id="yahoo_id" value="<?php echo($ym_id) ?>" size="40" class="code" /><br />
				<?php _e('Define the Yahoo! ID(s) of which online status will be displayed. Separate multiple values with spaces.', 'ym_status'); ?></td> 
			</tr> 
			<tr valign="top"> 
				<th scope="row"><?php _e('Text', 'ym_status'); ?>:</th> 
				<td colspan="3"><input name="button_title" type="text" id="button_title" value="<?php echo($ym_title) ?>" size="40" class="code" /><br />
				<?php _e('Specify the text value of title and alt attributes of the button image. It will show up when you hover the pointer on the button image and when the image has not loaded/fail to load','ym_status'); ?></td> 
			</tr> 
			<tr valign="top"> 
				<th scope="row" rowspan="<?php echo($pairs + 1); ?>">Status Button:</th>
				<td>&nbsp;</td>
				<td><?php _e('Name','ym_status') ?></td>
				<td><?php _e('Online','ym_status') ?></td>
				<td><?php _e('Offline','ym_status') ?></td>
			</tr>
				<?php
				$a = 1;
				foreach($online as $filename) {
					$fileinfo = pathinfo($filename);
					$name = substr($filename, 7);
					if($name == $ym_selected_button) {
						$checked = ' checked="checked"';
					} else {
						$checked = '';
					}
					?>
					
			<tr>
				<td><?php echo($a); ?></td>
				<td><label><input type="radio" name="ym_button_choice" value="<?php echo($name); ?>"<?php echo($checked) ?> /> <?php echo($name); ?></label></td>
				<td><img src="<?php echo("../" . YM_STATUS_IMG_DIR . $filename); ?>" alt="" /></td>
				<td><img src="<?php echo("../" . YM_STATUS_IMG_DIR . "offline-" . $name); ?>" alt="" /></td>
			</tr>
					<?
					$a ++;
				}
				?>
			</tr> 
		</table> 
		<p class="submit"><input type="submit" name="submit" value="<?php _e('Update Options &raquo;','ym_status') ?>" /></p>
		</form>
	</div>
	<?php
}

function get_ym_status($type = 'single') {
	global $ym_options;
	$wp_root = get_bloginfo('wpurl') . "/";
	if($type == 'single') {
		$id = $ym_options[id][0];
		?>
		<a href='ymsgr:sendim?<?php echo($id) ?>' title='<?php echo($ym_options['title']) ?>'><img src="<? echo($wp_root . YM_STATUS_DIR . "image.php") ?>" alt="<?php echo($ym_options['title']) ?>" /></a>
		<?php
	} elseif($type == 'list') {
		echo('<ul>');
		$a = 1;
		foreach($ym_options['id'] as $id) {
			echo('<li><a title="'.$ym_options[title].'" href=\'ymsgr:sendim?'.$id.'\'><img src="'.$wp_root.YM_STATUS_DIR.'image.php?id='.$a.'" alt="'.$ym_options[title].'" /></a></li>');
			$a ++;
		}
		echo("</ul>");
	}
}

if (is_admin()) {
	if($_POST['submit']) {
		$ym_id = trim($_POST['yahoo_id']);
		$ym_id_array = explode(" ", $ym_id);
		$button_title = stripslashes(htmlspecialchars(trim($_POST['button_title'])));
		$button_choice = $_POST['ym_button_choice'];
		$new_ym_options = $ym_options;
		$new_ym_options['id'] = $ym_id_array;
		$new_ym_options['title'] = $button_title;
		$new_ym_options['button'] = $button_choice;
		if($new_ym_options != $ym_options) {
			$ym_options = $new_ym_options;
			update_option('ym_status', serialize($ym_options));
		}
	}
	
	if($_GET['buttonname']) {
		$new_ym_options = $ym_options;
		$new_ym_options['button'] = $_GET['buttonname'];
		//only update the database if there is any options modification
		if($new_ym_options != $ym_options) {
			$ym_options = $new_ym_options;
			update_option('ym_status', serialize($ym_options));
		}
	}
	// activate this plugin
	add_action('activate_ym-online-status/ym_status.php','activated');
	// deactivate this plugin
	add_action('deactivate_ym-online-status/ym_status.php','deactivated');
}
add_action ('admin_menu', 'ym_status_menu');
?>
